// Entities that are used by bots for their 'pathfinding'
globalvar MOBAleftJump, MOBArightJump, MOBAleft, MOBAright, MOBAredSpawn, MOBAblueSpawn, MOBAtoggle;
MOBArightJump = object_add();
object_set_mask(MOBArightJump, MOBAentityS);
object_event_add(MOBArightJump, ev_draw, 0, 'if (MOBA.debug) draw_sprite(MOBAentityS, 2, x, y);'); 
MOBAleftJump = object_add();
object_set_mask(MOBAleftJump, MOBAentityS);
object_event_add(MOBAleftJump, ev_draw, 0, 'if (MOBA.debug) draw_sprite(MOBAentityS, 3, x, y);'); 

MOBAright = object_add();
object_set_mask(MOBAright, MOBAentityS);
object_event_add(MOBAright, ev_draw, 0, 'if (MOBA.debug) draw_sprite(MOBAentityS, 4, x, y);'); 
MOBAleft = object_add();
object_set_mask(MOBAleft, MOBAentityS);
object_event_add(MOBAleft, ev_draw, 0, 'if (MOBA.debug) draw_sprite(MOBAentityS, 5, x, y);'); 

MOBAredSpawn = object_add();
object_set_mask(MOBAredSpawn, MOBAentityS);
object_event_add(MOBAredSpawn, ev_draw, 0, 'if (MOBA.debug) draw_sprite(MOBAentityS, 0, x, y);'); 
MOBAblueSpawn = object_add();
object_set_mask(MOBAblueSpawn, MOBAentityS);
object_event_add(MOBAblueSpawn, ev_draw, 0, 'if (MOBA.debug) draw_sprite(MOBAentityS, 1, x, y);');

MOBAtoggle = object_add();
object_set_mask(MOBAtoggle, sprite64);
object_event_add(MOBAtoggle, ev_create, 0, 'lastChanged = false;');
object_event_add(MOBAtoggle, ev_draw, 0, 'if (MOBA.debug) draw_sprite(sprite64, 0, x, y);');  

object_event_add(RoomChangeObserver, ev_other, ev_room_start, '
    // initiate MOBA mode
    if (instance_exists(Generator) && (instance_exists(SpawnPointRed2) || instance_exists(SpawnPointBlue2))) {
        instance_create(0, 0, MOBAcontroller);
    }
');

globalvar MOBAcontroller;
MOBAcontroller = object_add();
object_event_add(MOBAcontroller, ev_create, 0,'
    first = true;
    respawnTime = 10 * 30 / global.delta_factor;
    if (global.isHost) alarm[0] = 10 * 30 / global.delta_factor;
    event_user(1);
    frame = 0;
    
    with(NoticeO) instance_destroy();
    instance_create(0,0,NoticeO);
    NoticeO.notice = NOTICE_CUSTOM;
    NoticeO.message = "Bots will spawn in 10 seconds";
'); 

object_event_add(MOBAcontroller, ev_step, ev_step_begin,'
    if(global.run_virtual_ticks) {
        frame += 1; 
        
        if (global.isHost) {            
            // Sync bots
            if ((frame mod MOBA.syncTime) == 0) {
                global.MOBAbuffer = buffer_create();
                write_ubyte(global.MOBAbuffer, 3);
                write_ubyte(global.MOBAbuffer, instance_number(MOBAbot));
                MOBA.sync = true;
                with(MOBAbot) event_user(12);
                with(MOBAturret) event_user(12);
                MOBA.sync = false;
                PluginPacketSend(global.GNPacketID, global.MOBAbuffer);
                buffer_destroy(global.MOBAbuffer);        
            }
        }
    }
    
    // Run bot AI here to reduce lag
    gunSetSolids();
    with(TeamGate) solid = false;
    var targetQueue, testDist, playercheck, jumpNow;
    jumpNow = false;
     
    with(MOBAbot) {
        if (global.run_virtual_ticks) {
            if (!humiliated && alarm[9] <= -1) {
                if (!super) {
                    // See if we can attack
                    if (state == 0) {
                        with(Character) {
                            if (player.team != other.team) {
                                if (point_distance(x, y, other.x, other.y) < 36) {
                                    other.image_index = 0;
                                    other.state = 1;
                                    other.alarm[6] = 14 / global.delta_factor;
                                    other.oldDir = other.dir;
                                    if (sign(x-other.x)) other.dir = 1;
                                    else other.dir = -1;
                                    break;
                                }
                            }
                        }
                    }
                    if (state == 0) {
                        with(Sentry) {
                            if (team != other.team && hp > 0) {
                                if (point_distance(x, y, other.x, other.y) < 36) {
                                    other.animIndex = 0;
                                    other.state = 1;
                                    other.alarm[6] = 14 / global.delta_factor; 
                                    other.oldDir = other.dir;
                                    if (sign(x-other.x)) other.dir = 1;
                                    else other.dir = -1;
                                    break;
                                }
                            }
                        }
                    }
                    if (state == 0) {
                        with(Generator) {
                            if (team != other.team) {
                                if (point_distance(x, y, other.x, other.y) < 36) {
                                    other.animIndex = 0;
                                    other.state = 1;
                                    other.alarm[6] = 14 / global.delta_factor; 
                                    other.oldDir = other.dir;
                                    if (sign(x-other.x)) other.dir = 1;
                                    else other.dir = -1;

                                    if (object_index == MOBAbot) {
                                        if (state == 0) {
                                            animIndex = 0;
                                            state = 1;
                                            alarm[6] = 14 / global.delta_factor; 
                                            oldDir = dir;
                                            if (sign(other.x-x)) dir = 1;
                                            else dir = -1;
                                        }
                                    }
                                    break;
                                }
                            }
                        }
                    }
                } else if ((other.frame mod 4) == 0) {                      
                    nearestTarget = noone;
                    targetQueue = ds_priority_create();
                    
                    // Build a queue of potential targets
                    with(Character) {
                        testDist = distance_to_object(other);
                        if(!cloak && testDist<=100 && player.team != other.team) {
                            ds_priority_add(targetQueue, id, testDist);
                        }
                    }
                    
                    with(Sentry) {
                        testDist = distance_to_object(other);
                        if(testDist<=90 && team != other.team && hp > 0) {
                            ds_priority_add(targetQueue, id, testDist);
                        }
                    }
                    
                    with(Generator) {
                        testDist = distance_to_object(other);
                        if(testDist<=50 && team != other.team) {
                            ds_priority_add(targetQueue, id, testDist+100);
                        }
                    }
                    
                    while(!nearestTarget && !ds_priority_empty(targetQueue)) {
                        playercheck = ds_priority_delete_min(targetQueue);
                        if(collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
                            && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
                            && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
                            nearestTarget = playercheck;
                        }
                    }
                
                    ds_priority_destroy(targetQueue);
                    
                    if (instance_exists(nearestTarget)) {
                        with(Spy) {
                            if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
                                other.nearestTarget = id;
                            }
                        }
                        if (!canAirblast && alarm[4] < 0) alarm[4] = airblastTime / 5 / global.delta_factor;

                        aimDirection = point_direction(x,y,nearestTarget.x,nearestTarget.y);
                        
                        // Give superdroids a phlogistinator because that lags less :)
                        if (point_distance(x, y, nearestTarget.x, nearestTarget.y) < 26 && canAirblast) {
                            // Get out of my face!
                            playsound(x,y,CompressionBlastSnd);
                            poof = instance_create(x+lengthdir_x(25,aimDirection),y+lengthdir_y(25,aimDirection),AirBlastO);
                            if (image_xscale == 1) {
                                poof.image_xscale = 1;
                                poof.image_angle = aimDirection;
                            } else {
                                poof.image_xscale = -1;
                                poof.image_angle = aimDirection+180;
                            }
                            
                            with(nearestTarget) {
                                motion_set(other.aimDirection, 12);
                                if (object_index == MOBAbot) {
                                    state = 0;
                                    alarm[9] = 10 / global.delta_factor;
                                }
                            }
                            
                            shooting = false;
                            canAirblast = 0;
                            alarm[4] = airblastTime / global.delta_factor;
                            alarm[1] = 30 / global.delta_factor;     
                                               
                        } else if(nearestTarget.ubered == 0) {
                            damageAuto(id, nearestTarget, hitDamage*2);
                            if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                                if (nearestTarget.lastDamageDealer != nearestTarget.player){
                                    nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                                    nearestTarget.alarm[4] = nearestTarget.alarm[3];
                                }
                            }
                            nearestTarget.alarm[3] = ASSIST_TIME;
                            nearestTarget.lastDamageDealer = id;
                            nearestTarget.lastDamageSource = 4152;
                        }
                        
                        if(global.particles == PARTICLES_NORMAL) {
                            effect_create_below(ef_smokeup, x+lengthdir_x(random(140),aimDirection), y-8+lengthdir_y(random(140),aimDirection), 0, c_gray);
                        }
                        
                        shooting = true;
                        
                        if (point_distance(x, y, nearestTarget.x, nearestTarget.y) < 70) state = 2;
                        else state = 0;
                        
                        alarm[1] = 15 / global.delta_factor;
                        oldDir = dir;
                        if(((aimDirection+270) mod 360)>180) {
                            dir=1;
                            drawDirection = aimDirection;
                        } else {
                            dir=-1;
                            drawDirection = aimDirection+180;
                        }
                    } else {
                        shooting = 0;
                        canAirblast = 0;
                    }
                }
            }
        }
        hspeed *= global.delta_factor;
        vspeed *= global.delta_factor;
        
        stuck = !place_free(x, y);
        onFloor = !place_free(x,y+1);

        // Collide
        if(!place_free(x+hspeed, y+vspeed) || stuck) {
            // We are hitting the floor or are completely stuck
            if(vspeed > 0 && place_free(x+hspeed, y) || stuck) {
                // push up
                	y -= 3;
                move_contact_solid(270, vspeed + 3);
                vspeed = 0;
                jumping = false;
            }
            
            // there is something else blocking us.
            if (!place_free(x+hspeed, y + vspeed)) {
                // A step
                if (place_free(x + hspeed, y + vspeed - 6)) {
                    y -= 6;
                }  
                // Ceiling
                else if (place_free(x + hspeed, y + vspeed + 6) and abs(hspeed) >= abs(vspeed)) {
                    y += 6;
                } else canMove = false;
                
                // A bigger object we can jump over
                canJump = place_free(x+hspeed, y+vspeed-60) || place_free(x+hspeed, y+vspeed-36);
                
                if (canJump && onFloor && state != 1 && !canMove) {
                    // Try jumping
                    if (!jumping && state != 1 && onFloor) {
                        jumpNow = true;
                        jumping = true;
                    } else if (!onFloor && !jumping) {
                        hspeed = 0;
                    }
                }
                
                // A wall we cannot jump over
                else if (vspeed == 0 && !canJump && !canMove) {
                    x += hspeed * global.delta_factor / 2;
                    hspeed *= -1;
                    dir *= -1;
                }
            }
        }
        
        hspeed /= global.delta_factor;
        vspeed /= global.delta_factor;

        // apply gravity
        if (!onFloor) vspeed += 0.6  * global.delta_factor; 
        if (jumpNow) {
            vspeed -= 8;
            jumpNow = false;
        }

        // Do not try moving sideways when there is a wall blocking us
        if (canMove && !humiliated && (state == 0 || (state == 2 && jumping))) x += hspeed * global.delta_factor;
        canMove = true;
        
        x -= hspeed;
        y -= vspeed;
        y += vspeed * global.delta_factor;
        
    }
    
    // Make turrets shoot
    if ((other.frame mod 6) == 0 && global.run_virtual_ticks) {
        with(MOBAturret) {
            if (destroyed) continue;
    
            if(((aimDirection+270) mod 360)>180) {
                gunXScale=1;
                drawDir = aimDirection;
            } else {
                gunXScale=-1;
                drawDir = aimDirection+180;
            }
            
            nearestTarget = noone;
            targetQueue = ds_priority_create();
            
            // Build a queue of potential targets
            with(Character) {
                testDist = distance_to_object(other);
                if(!cloak && testDist<=325 && player.team != other.team) {
                    ds_priority_add(targetQueue, id, testDist+250);
                }
            }
            
            with(Sentry) {
                testDist = distance_to_object(other);
                if(testDist<=325 && team != other.team) {
                    ds_priority_add(targetQueue, id, testDist+250);
                }
            }
            
            with(MOBAbot) {
                testDist = distance_to_object(other);
                if(testDist<=250 && team != other.team) {
                    ds_priority_add(targetQueue, id, testDist);
                }
            }
            
            while(!nearestTarget && !ds_priority_empty(targetQueue)) {
                playercheck = ds_priority_delete_min(targetQueue);
                if(collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
                    && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
                    && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
                    nearestTarget = playercheck;
                }
            }
        
            ds_priority_destroy(targetQueue);
            
            // Shoot enemies that are shooting at us outside normal range
            if (!nearestTarget && trueTarget) {
                if (instance_exists(trueTarget)) {
                    if (collision_line(x,y,trueTarget.x,trueTarget.y,Obstacle,true,true)<0
                        && collision_line(x,y,trueTarget.x,trueTarget.y,IntelGate,true,true)<0
                        && collision_line(x,y,trueTarget.x,trueTarget.y,BulletWall,true,true)<0) {
                        nearestTarget = trueTarget;
                    } else trueTarget = noone;
                } else trueTarget = noone;
            } else trueTarget = noone;
            
            if(!nearestTarget) {
                if(image_xscale>0) aimDirection = 0;
                else aimDirection = 180;
            } else {
                // set cloaked spy as target if theyre in the way
                with(Spy) {
                    if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
                        other.nearestTarget = id;
                    }
                } 
                
                aimDirection = point_direction(x,y-31,nearestTarget.x,nearestTarget.y);
                
                playsound(x,y,ShotgunSnd);
                if(nearestTarget.ubered == 0) {
                    damageAuto(id, nearestTarget, hitDamage);
                    if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                        if (nearestTarget.lastDamageDealer != nearestTarget.player){
                            nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                            nearestTarget.alarm[4] = nearestTarget.alarm[3];
                        }
                    }
                    nearestTarget.alarm[3] = ASSIST_TIME;
                    nearestTarget.lastDamageDealer = noone;
                    nearestTarget.lastDamageSource = 4151;
                    if(global.gibLevel > 0 and object_is_ancestor(nearestTarget.object_index, Character))
                    {
                        blood = instance_create(nearestTarget.x,nearestTarget.y,Blood);
                        blood.direction = direction-180;
                        dealFlicker(nearestTarget);
                    }
                    if (nearestTarget.object_index == MOBAbot) {
                        shield = 0;
                        alarm[2] = 60 / global.delta_factor;
                    }
                }
                shooting=true;
            }
        }
    }
    
    gunUnsetSolids();
');
    
object_event_add(MOBAcontroller, ev_alarm, 0,'
    if (first) {
        playsound(view_xview[0]+view_wview[0]/2, view_yview[0]+view_hview[0]/2, SirenSnd);
        with(NoticeO) instance_destroy();
        instance_create(0,0,NoticeO);
        NoticeO.notice = NOTICE_CUSTOM;
        NoticeO.message = "Bots have spawned";
        first = false;
    }

    //Tell the clients to spawn bots too
    var buffer;
    buffer = buffer_create();
    write_ubyte(buffer, 4);
    PluginPacketSend(global.GNPacketID, buffer);
    buffer_destroy(buffer);

    alarm[0] = respawnTime;
    event_user(0);
');

object_event_add(MOBAcontroller, ev_other, ev_user0, '
    if (instance_number(MOBAbot) < MOBA.botLimit) {  
        with(MOBAredSpawn) {
            var bot;
            bot = instance_create(x, y, MOBAbot);
            bot.dir = 1;
            bot.direction = 0;
            bot.team = TEAM_RED;
        }
        with(MOBAblueSpawn) {
            var bot;
            bot = instance_create(x, y, MOBAbot);
            bot.dir = -1
            bot.direction = 180;
            bot.team = TEAM_BLUE;
        }
    }
');

// Place all MOBA entities 
object_event_add(MOBAcontroller, ev_other, ev_user1, '
    with(Player) {
        for(i=0; i<6; i+=1) GNupgrades[i] = false;
        spentPoints = 0; 
    }

    with(Generator) {
        maxHp = 1000;
        hp = maxHp;
        regenerationBuffer = 30;
        maxShieldResistance = 1;
        maxShieldHp = 600;
        shieldHp = maxShieldHp;
        ubered = 0;
    }
    
    with(SpawnPointRed1) {
        var bot;
        bot = instance_create(x, y, MOBAturret);
        bot.team = TEAM_RED;
        instance_destroy();
    }
    with(SpawnPointBlue1) {
        var bot;
        bot = instance_create(x, y, MOBAturret);
        bot.team = TEAM_BLUE;
        bot.image_xscale = -1;
        instance_destroy();
    }
    
    with(SpawnPointRed2) {
        instance_create(x, y, MOBAredSpawn);
        instance_destroy();
    }
    with(SpawnPointBlue2) {
        instance_create(x, y, MOBAblueSpawn);
        instance_destroy();
    }
    with(SpawnPointRed3) {
        instance_create(x, y, MOBArightJump);
        instance_destroy();
    }
    with(SpawnPointBlue3) {
        instance_create(x, y, MOBAleftJump);
        instance_destroy();
    }
    with(SpawnPointRed4) {
        instance_create(x, y, MOBAright);
        instance_destroy();
    }
    with(SpawnPointBlue4) {
        instance_create(x, y, MOBAleft);
        instance_destroy();
    }
    
    with(CaptureZone) {
        instance_create(x, y, MOBAtoggle);
        instance_destroy();
    }
');

/****************************************
 * placeholder MOBA turret
****************************************/
globalvar MOBAturretDummy;
MOBAturretDummy = object_add();
object_event_add(MOBAturretDummy, ev_create, 0, '
    image_speed = 0;
    sprite_index = MOBAturretBaseS;
');

/****************************************
 * MOBA turrets
****************************************/
globalvar MOBAturret;
MOBAturret = object_add();
object_set_parent(MOBAturret, Sentry);
object_set_mask(MOBAturret, MOBAturretBaseS);

object_event_add(MOBAturret, ev_create, 0, '
    hp = 1000;
    maxHp = hp;
    team = TEAM_RED;
    alarm[10] = 1;
    wall = noone;
    destroyed = false;
    ownerPlayer = noone;    //Required for sentry objects
    humiliated = 0;
    nearestTarget = noone;
    hitDamage = 9;
    refireTime = 6;
    aimDirection = 0;
    gunXScale = 1;
    shooting=true;
    readyToShoot=false;
    trueTarget = noone;
    drawDir = 0;
    ubered = 0;
    shield = 1;
    shieldIndex = 5;
    first = true;

    object = id;
    healer = noone;
    name = "a superdroid";
    stats[KILLS] = 0;
    stats[ASSISTS] = 0;
    stats[DESTRUCTION] = 0;
    stats[DEFENSES] = 0;
    stats[BONUS] = 0;
    stats[POINTS] = 0;
    roundStats[KILLS] = 0;
    roundStats[ASSISTS] = 0;
    roundStats[DESTRUCTION] = 0;
    roundStats[DEFENSES] = 0;
    roundStats[BONUS] = 0;
    roundStats[POINTS] = 0;
');
object_event_add(MOBAturret, ev_destroy, 0, '//nope');
object_event_add(MOBAturret, ev_step, ev_step_begin, '//nope');
object_event_add(MOBAturret, ev_step, ev_step_end, '//nope');
object_event_add(MOBAturret, ev_other, ev_user1, '
    if (team != global.winners) humiliated = 1;
');

object_event_add(MOBAturret, ev_other, ev_user12, '
    if (!MOBA.sync) exit;
    write_ubyte(global.MOBAbuffer, ceil(hp/3.95));
');

object_event_add(MOBAturret, ev_other, ev_user13, '
    if (!MOBA.sync) exit;
    hp = read_ubyte(global.MOBAbuffer)*3.95;
    
    if (hp <= 0 && !destroyed) {
        hp = 0;
        destroyed = true;
        if (instance_exists(wall)) with(wall) instance_destroy();
        dummy = instance_create(x,y, MOBAturretDummy);
        dummy.image_index = team*2 + 1;
        dummy.image_xscale = image_xscale;
        
        if (!first) {
            instance_create(x, y, Explosion);
            playsound(x, y, ExplosionSnd);
            with(Player) {
                if (team != other.team) stats[POINTS] += 5;
            }
            
            with(KillLog) {
                var map;
                map = ds_map_create();
                ds_map_add(map, "name1", "A turret");
                ds_map_add(map, "team1", other.team);           
                ds_map_add(map, "name2", "");
                ds_map_add(map, "team2", other.team);
                ds_map_add(map, "inthis", true);
                ds_map_add(map, "string", " has been destroyed!");
                ds_map_add(map, "weapon", ExplodeKL);
                ds_list_add(kills, map);
                
                if (ds_list_size(kills) > 5) {
                    ds_map_destroy(ds_list_find_value(kills, 0));
                    ds_list_delete(kills, 0);
                }
                
                alarm[0] = 30*5;
            }
        }
        
        // Hide these because they are still needed for syncing
        x = -100;
        y = -100;
        visible = false;
    }
    
    first = false;
');
object_event_add(MOBAturret, ev_collision, FragBox, '//nope');
object_event_add(MOBAturret, ev_collision, KillBox, '//nope');
object_event_add(MOBAturret, ev_collision, TeamGate, '//nope');
object_event_add(MOBAturret, ev_collision, IntelGate, '//nope');

object_event_add(MOBAturret, ev_alarm, 10, '
    if (team == TEAM_RED) wall = instance_create(x, y-37, RedTeamGate);
    else {
        wall = instance_create(x, y-37, BlueTeamGate);
        image_xscale = -1;
    }
');

object_event_add(MOBAturret, ev_step, ev_step_begin, '
    if (hp <= 0 && !destroyed && global.isHost) {
        hp = 0;
        destroyed = true;
        if (instance_exists(wall)) with(wall) instance_destroy();
        dummy = instance_create(x,y, MOBAturretDummy);
        dummy.image_index = team*2 + 1;
        dummy.image_xscale = image_xscale;
        
        instance_create(x, y, Explosion);
        playsound(x, y, ExplosionSnd);
        
        with(KillLog) {
            var map;
            map = ds_map_create();
            ds_map_add(map, "name1", "A turret");
            ds_map_add(map, "team1", other.team);           
            ds_map_add(map, "name2", "");
            ds_map_add(map, "team2", other.team);
            ds_map_add(map, "inthis", true);
            ds_map_add(map, "string", " has been destroyed!");
            ds_map_add(map, "weapon", ExplodeKL);
            ds_list_add(kills, map);
            
            if (ds_list_size(kills) > 5) {
                ds_map_destroy(ds_list_find_value(kills, 0));
                ds_list_delete(kills, 0);
            }
            
            alarm[0] = 30*5;
        }
        
        // Hide these because they are still needed for syncing
        x = -100;
        y = -100;
        visible = false;
        
        with(Player) {
            if (team != other.team) stats[POINTS] += 5;
        }
    }
');
object_event_add(MOBAturret, ev_alarm, 0, 'readyToShoot = true;');
object_event_add(MOBAturret, ev_alarm, 1, 'trueTarget = noone;');
object_event_add(MOBAturret, ev_alarm, 2, 'shield = 1;');

object_event_add(MOBAturret, ev_collision, Mine, ' 
    if(team != other.team){
        if (x<other.x) with(other) motion_set(50, 4);
        else with(other) motion_set(130, 4); 
        other.stickied = false;
        playsound(x, y, CompressionBlastSnd);
    }
');

object_event_add(MOBAturret, ev_draw, 0, ' 
    draw_sprite_ext(MOBAturretBaseS, team*2 + destroyed, x, y, image_xscale, 1, 0, c_white, 1);
    if (!destroyed) {
        draw_set_alpha(1);
        draw_healthbar(x-15, y-50, x+15, y-45,hp/maxHp*100,c_black,c_red,c_green,0,true,true);
        
        draw_sprite_ext(MOBAturretS, shooting + team*2, x, y-31, gunXScale, 1, drawDir, c_white, 1);
        if (shooting) {
            if(instance_exists(nearestTarget)){
                xshootoffset=4*gunXScale;
                draw_set_alpha(0.6);
                draw_line_width_color(x+lengthdir_x(10,aimDirection)-xshootoffset,y+lengthdir_y(10,aimDirection)-25,nearestTarget.x+random(25)-12,nearestTarget.y+random(25)-12,2,c_yellow,c_black);
            }
            shooting=false;
        }
        
        if (shield) {
            if (shieldIndex >= 5) draw_sprite_ext(GNturretShieldS, 0, x, y-10, -image_xscale, 1, 0, c_white, 0.5);
            else {
                shieldIndex += 0.3 * global.delta_factor;
                draw_sprite_ext(GNturretShieldS, floor(shieldIndex), x, y-10, -image_xscale, 1, 0, c_white, 1);
            }
        }
    }
');

/****************************************
 * Moba (super) droids
****************************************/
globalvar MOBAbot;
MOBAbot = object_add();
object_set_parent(MOBAbot, Generator);
object_set_mask(MOBAbot, MOBAbotMoveS)
object_event_add(MOBAbot, ev_destroy, 0, '//nope');
object_event_add(MOBAbot, ev_step, ev_step_end, '//nope');
object_event_add(MOBAbot, ev_other, ev_user12, '
    if (!MOBA.sync) exit;
    
    write_ushort(global.MOBAbuffer, round(x*5))
    write_ushort(global.MOBAbuffer, round(y*5));
    write_byte(global.MOBAbuffer, round(vspeed*8.5));
    write_ubyte(global.MOBAbuffer, ceil(hp));
    temp = 0;
    temp += min(3, state);
    if (dir == 1) temp |= $04;
    if (team == TEAM_BLUE) temp |= $08;
    if (super) temp |= $10;
    if (folowNavBox) temp |= $20;
    write_ubyte(global.MOBAbuffer, temp);
');
object_event_add(MOBAbot, ev_other, ev_user13, '
    if (!MOBA.sync) exit;
    
    x = read_ushort(global.MOBAbuffer)/5;
    y = read_ushort(global.MOBAbuffer)/5;
    vspeed = read_byte(global.MOBAbuffer)/8.5;
    hp = read_ubyte(global.MOBAbuffer);
    temp = read_ubyte(global.MOBAbuffer);
    state = temp & $03;
    if (temp & $04 != 0) dir = 1;
    else dir = -1;
    if (temp & $08 != 0) team = TEAM_BLUE;
    else team = TEAM_RED;
    if (temp & $10 != 0) super = 1;
    if (temp & $20 != 0) folowNavBox = 1;
');
object_event_add(MOBAbot, ev_collision, KillBox, 'hp = 0;');
object_event_add(MOBAbot, ev_collision, FragBox, 'hp = 0;');
object_event_add(MOBAbot, ev_other, ev_user1, '
    if (team != global.winners) humiliated = 1;
');

object_event_add(MOBAbot, ev_create, 0, '
    team = TEAM_RED;
    hspeed = 4;
    sprite_index = SentryRed;
    jumping = false;
    canMove = false;
    animIndex = 0;
    dir = 1;
    state = 0;
    idle = false;
    hp = 100;
    maxHp = 100;
    ownerPlayer = noone;    // Required for sentry objects
    lastDamageDealer = noone;
    oldDir = 1;
    damage = 20;
    super = 0;
    humiliated = 0;
    touchToggle = 0;
    touchedNavBox = 0;
    folowNavBox = 1;
    shield = 0;
    shieldIndex = 0;
    ubered = 0;
    shieldResistance = 0;
    regenerationBuffer = 0;
    shieldHp = 0;
    fireIndex = 0;
        
    shooting = 0;
    aimDirection = 0;
    readyToShoot = 1;
    canAirblast = 0;
    refireTime = 2;
    airblastTime = 45;
    baseAimDir = random(100)-50;
    wiggle = 0;
    wiggleDir = 1;
    aimDirection = baseAimDir;
    drawDirection = baseAimDir;
    hitDamage = 3;
    
    object = id;
    healer = noone;
    name = "a superdroid";
    stats[KILLS] = 0;
    stats[ASSISTS] = 0;
    stats[DESTRUCTION] = 0;
    stats[DEFENSES] = 0;
    stats[BONUS] = 0;
    stats[POINTS] = 0;
    roundStats[KILLS] = 0;
    roundStats[ASSISTS] = 0;
    roundStats[DESTRUCTION] = 0;
    roundStats[DEFENSES] = 0;
    roundStats[BONUS] = 0;
    roundStats[POINTS] = 0;
');

object_event_add(MOBAbot, ev_step, ev_step_normal, '//nope');
object_event_add(MOBAbot, ev_step, ev_step_begin, '
    if (hp <= 0) {
        instance_destroy();
        instance_create(x, y, Explosion);
        playsound(x,y, ExplosionSnd);
        
        if (lastDamageDealer != noone && instance_exists(lastDamageDealer)) {
            if (lastDamageDealer.object_index == Player) lastDamageDealer.stats[POINTS] += 0.5;
        } 
    }
    
    targetSpeed = 4 * dir;
    if (abs(targetSpeed - hspeed) < 0.5*global.delta_factor) hspeed = targetSpeed;
    else hspeed += sign(targetSpeed-hspeed)*global.delta_factor;
    
    if (state == 0) {   //walking
        animIndex += 0.25 * hspeed/3.6 * dir * global.delta_factor;
        if (animIndex >= 4) animIndex = 0;
        else if (animIndex < 0) animIndex = 4;
        if (super && !shooting) {
            drawDirection = baseAimDir + wiggle;
            wiggle += wiggleDir * global.delta_factor;
            if (wiggle > 10 && wiggleDir > 0) wiggleDir = -1;
            else if (wiggle < -10 && wiggleDir < 0) wiggleDir = 1;
        }
    } else if (state == 1) {    //attacking
        animIndex += 0.5 * global.delta_factor;
        if (animIndex >= 14)  {
            state = 0;
            animIndex = 0;
            dir = oldDir;
        }
    }
');
object_event_add(MOBAbot, ev_alarm, 1, '
    state = 0;
    dir = oldDir;
    drawDirection = baseAimDir;
');
object_event_add(MOBAbot, ev_alarm, 2, 'readyToShoot = true');
object_event_add(MOBAbot, ev_alarm, 3, 'loopsoundstop(FlamethrowerSnd);');
object_event_add(MOBAbot, ev_alarm, 4, 'canAirblast = true;');
object_event_add(MOBAbot, ev_alarm, 6, 'event_user(6)');
object_event_add(MOBAbot, ev_alarm, 7, 'touchToggle = false;');
object_event_add(MOBAbot, ev_alarm, 8, 'shield = false;');
object_event_add(MOBAbot, ev_alarm, 9, '//nope');

object_event_add(MOBAbot, ev_other, ev_user3, '
    // Try jumping
    if (!jumping && state != 1 && onFloor) {
        vspeed -= 8;
        jumping = true;
    } else if (!onFloor && !jumping) {
        hspeed = 0;
    }
');
object_event_add(MOBAbot, ev_other, ev_user6, '
    if (state == 0) exit;
    var attacked;
    attacked = false;
    with(Character) {
        if (player.team != other.team && ubered == 0) {
            if (abs(y-other.y) < 40 && ((other.dir == 1 && x-other.x > -5 && x-other.x < 45) || (other.dir == -1 && other.x-x > -5 && other.x-x < 45))) {
                damageCharacter(other.id, id, other.damage);
                lastDamageDealer = noone;
                lastDamageSource = 4150;
                dealFlicker(id);
                repeat(3) {
                    var blood;
                    blood = instance_create(other.x + 30*other.dir, other.y, Blood);
                    blood.direction = random(360);
                }
                motion_add(-other.dir*90+90, 0.7);
                attacked = true;
                break;
            }
        }
    }
    if (!attacked) {
        with(Sentry) {
            if (team != other.team && hp > 0) {
                if (abs(y-other.y) < 40 && ((other.dir == 1 && x-other.x > -5 && x-other.x < 45) || (other.dir == -1 && other.x-x > -5 && other.x-x < 45))) {
                    damageSentry(other.id, id, other.damage);
                    lastDamageDealer = noone;
                    lastDamageSource = 4150;	
                    attacked = true;
                    if (object_index == MOBAbot) motion_add(-other.dir*90+90, 1.5);
                    break;
                }
            }
        }
    }
    if (!attacked) {
        with(Generator) {
            if (team != other.team) {
                if (abs(y-other.y) < 40 && ((other.dir == 1 && x-other.x > -5 && x-other.x < 45) || (other.dir == -1 && other.x-x > -5 && other.x-x < 45))) {
                    damageGenerator(other.id, id, other.damage);
                    attacked = true;
                    break;
                }
            }
        }
    }
');

// Some map entites change the default behaviour
object_event_add(MOBAbot, ev_collision, MOBArightJump, 'if (dir == 1 && folowNavBox) event_user(3);');
object_event_add(MOBAbot, ev_collision, MOBAleftJump, 'if (dir == -1 && folowNavBox) event_user(3);');
object_event_add(MOBAbot, ev_collision, MOBAright, '
    if (dir == -1 && folowNavBox) {
        hspeed *= -1;
        dir = 1;
        touchedNavBox = 1;
    }
');
object_event_add(MOBAbot, ev_collision, MOBAleft, '
    if (dir == 1 && folowNavBox) {
        hspeed *= -1;
        dir = -1;
        touchedNavBox = 1;
    }
');
object_event_add(MOBAbot, ev_collision, MOBAtoggle, '
    alarm[7] = 2;
    if (!touchToggle) {
        touchToggle = true;
        if (!folowNavBox) folowNavBox = 1;
        else {
            if (!other.lastChanged || touchedNavBox) folowNavBox = 0;
            other.lastChanged = !other.lastChanged; 
       } 
    }
');
object_event_add(MOBAbot, ev_collision, MoveBoxRight, 'hspeed = 5');
object_event_add(MOBAbot, ev_collision, MoveBoxLeft, 'hspeed = -5');
object_event_add(MOBAbot, ev_collision, MoveBoxUp, 'vspeed = -5');
object_event_add(MOBAbot, ev_collision, MoveBoxDown, 'vspeed = 5');

object_event_add(MOBAbot, ev_destroy, 0, '
    //loopsoundstop(FlamethrowerSnd);
    with(Flame) {
        if (ownerPlayer == other.id) instance_destroy();
    }
    
    // Even out small differences in timing
    if (alarm[6] <= 3/global.delta_factor) {
        event_user(6);
    }
');

object_event_add(MOBAbot, ev_draw, 0, '
    if (!super) {
        if (state == 0) draw_sprite_ext(MOBAbotMoveS, team*4+floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
        else draw_sprite_ext(MOBAbotMeleeS, team*14+floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
    } else {
        draw_sprite_ext(MOBAbotMove2S, team*4+floor(animIndex), x+5*dir, y, dir, 1, 0, c_white, 1);
        if (!shooting) draw_sprite_ext(FlamethrowerS, team, x, y, dir, 1, drawDirection, c_white, 1);
        else {
            draw_sprite_ext(FlamethrowerFS, team*3 + 1, x, y, dir, 1, drawDirection, c_white, 1);
            draw_sprite_ext(MOBAphlogS, fireIndex, x+lengthdir_x(20, aimDirection), y+lengthdir_y(20, aimDirection), 0.9, 0.9, aimDirection, c_white, 0.8);
            fireIndex += 0.3 * global.delta_factor;
            if (fireIndex >= 4) fireIndex = 0;
        }
    }
    
    if (shield) {
        draw_sprite_ext(GNheavyShieldS, floor(shieldIndex) + team*2, x-4, y, 1.3, 1.3, 0, c_white, 0.5);
        shieldIndex += 0.2 * global.delta_factor;
        if (shieldIndex >= 2) shieldIndex = 0;
    }
    
    draw_set_alpha(1);
    draw_healthbar(x-10, y-30, x+10, y-25,hp/maxHp*100,c_black,c_red,c_green,0,true,true);
');